//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "main.h"
#include "time.h"
#include "statistik.h"
#include "fstream.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfmMain *fmMain;

//    
struct SlipStatRec
{
 MqlStr       Broker;
 int          TotalDeals;
 double       SumOpenSlip;
 double       SumCloseSlip;
 int          Requotes;
};
//      
char     *p;
HANDLE   hSem           = NULL;       // 
HANDLE   hData          = NULL;       //    
Data     *pData         = NULL;		  //    
HANDLE   hDeals         = NULL;       // 
DealRec  *pDeals        = NULL;       //--
HANDLE	 hDlsJournal	= NULL;       // 
DealRec	 *pDlsJournal   = NULL;
HANDLE   hCaptions      = NULL;       // /id (  )
MqlStr   *pCaptions     = NULL;
HANDLE   hDigits        = NULL;       // 
int      *pDigits       = NULL;
SlipStatRec  *pSlipStat = NULL;       //   

//   
LPCTSTR pSemCaption         = "N_STAT_SEM";	      // 
LPCTSTR pDataCaption        = "N_STAT_DATA";	  //  
LPCTSTR pDealsCaption       = "N_STAT_DEALS";     //  
LPCTSTR pDlsJournalCaption	= "N_STAT_DLSJOURNAL";//  
LPCTSTR pCaptionsCaption    = "N_STAT_CAPTIONS";  // /id
LPCTSTR pDigitsCaption      = "N_STAT_DIGITS";    // 

//
#define SSFILESIZE 100

int   DTsize          = 0;                           // 
int   CTsize          = 0;
int   JTsize          = 0;
int   BrokerNum       = 0;                           //  
int   CurNum          = 0;                           //  
bool  Work            = false;                       //    

TDateTime   *TimeInMarketOpen   = NULL;// 
TDateTime   *TimeInMarketClose  = NULL;
TDateTime   *OpenTime           = NULL;// /
TDateTime   *CloseTime          = NULL;

const TDateTime StartTime   = Time();
int   clbADSel              = -1;
int   clbJDSel              = -1;

bool JDTChangeFlag   = false;
//bool ADTChangeFlag   = false;

int l8timer = 0;
int l9timer = 0;
int l10timer = 0;

//  
int ActDeals    = 0;
int DoneDeals   = 0;
int SumPft      = 0;

// ""
MqlStr ZeroStr;

//
FILE        *SlipStatFile;
ofstream    *JournalFile;

//           
char *StrBuf = new char[CLEN + 1];
void PutToStrBuf(char *cap)
{
 int i;
 for(i = 0; i < CLEN; i++)
         StrBuf[i] = cap[i];
 StrBuf[CLEN] = '\0';
}

//   
bool RefreshSlipStat(int BrokerID, double Price, int Slippage, int Requotes, bool OpenOrClose/*true/false*/)
{
  int i = -1;
  bool EqvFlag, EmptyFlag;
  MqlStr BrokerName;
  MqlStrCopy(&BrokerName, &pCaptions[BrokerID]);
  do
  {
   i++;
   EqvFlag = EqvStr(&pSlipStat[i].Broker, &BrokerName);
   EmptyFlag = EqvStr(&pSlipStat[i].Broker, &ZeroStr);
  }
  while((!EqvFlag) && (!EmptyFlag) && (i < 100));
  if(i >= 100) return false;
  if(EmptyFlag)
   MqlStrCopy(&pSlipStat[i].Broker, &BrokerName);

  if(OpenOrClose)
   pSlipStat[i].SumOpenSlip += Slippage;
  else
  {
   pSlipStat[i].SumCloseSlip += Slippage;
   pSlipStat[i].TotalDeals++;
  }
  pSlipStat[i].Requotes += Requotes;
  return true;
}

//     
bool RefreshSlipStatFile(void)
{
 if((SlipStatFile = fopen("SlipStat.log", "w")) == 0)
 {
     MessageBox(NULL, "!      ,    .", "", MB_OK);
     return false;
 }
 int i = 0;
 while(!EqvStr(&pSlipStat[i].Broker, &ZeroStr))
 {
  if(!fwrite(&pSlipStat[i], sizeof(SlipStatRec), 1, SlipStatFile))
  {
   MessageBox(NULL, "!       ,     .", "", MB_OK);
   return false;
  }
  i++;
 }
 fclose(SlipStatFile);
 return true;
}

//  
bool RefreshJournalFile(char *fname, int type)
{
 int dls = ActDeals;
 int i = 0, j;
 JournalFile = new ofstream(fname, ios::out|ios::app);
 if(!JournalFile) return false;
 *JournalFile << ":  " << DateToStr(Date()).c_str() << "    " << TimeToStr(Time()).c_str() << endl;
switch(type)
{
case 0:     // 
 if(dls > 0)
 {
    //
    *JournalFile << "<TABLE border=\"1\"><TR>" << endl;
    for(j = 0; j < fmMain->DealTable->ColCount; j++)
    {
        if(fmMain->DealTable->Cells[j][0] != " ")
        {
            *JournalFile << "<TD width=\"150\">";
            *JournalFile << fmMain->DealTable->Cells[j][0].c_str();
            *JournalFile << "</TD>";
        }
    }
    *JournalFile << "</TR>" << endl;

WaitForSingleObject(hSem, INFINITE);//
    //  
    while((dls > 0) && (i < DTsize))
    {
        if(pDeals[i].Index >= 0)
        {
            *JournalFile << "<TR>";
            for(j = 0; j < fmMain->DealTable->ColCount; j++)
            {
                if(fmMain->DealTable->Cells[j][i + 1] != "")
                {
                    *JournalFile << "<TD width=\"150\">";
                    *JournalFile << fmMain->DealTable->Cells[j][i + 1].c_str();
                    *JournalFile << "</TD>";
                }
            }
            *JournalFile << "</TR>" << endl;
            dls--;
        }
        i++;
    }
    *JournalFile << "</TABLE>" << endl;
ReleaseMutex(hSem);//
 }
 break;
case 1:    // 
 i = 0;
 dls = DoneDeals;;
 if(dls > 0)
 {
    //
    *JournalFile << "<TABLE border=\"1\"><TR>" << endl;
    for(j = 0; j < fmMain->JournalTable->ColCount; j++)
    {
        if(fmMain->JournalTable->Cells[j][0] != " ")
        {
            *JournalFile << "<TD width=\"150\">";
            *JournalFile << fmMain->JournalTable->Cells[j][0].c_str();
            *JournalFile << "</TD>";
        }
    }
    *JournalFile << "</TR>" << endl;

WaitForSingleObject(hSem, INFINITE);//
    //  
    while((dls > 0) && (i < JTsize))
    {
        if(pDlsJournal[i].Index >= 0)
        {
            *JournalFile << "<TR>";
            for(j = 0; j < fmMain->JournalTable->ColCount; j++)
            {
                if(fmMain->JournalTable->Cells[j][i + 1] != " ")
                {
                    *JournalFile << "<TD width=\"150\">";
                    *JournalFile << fmMain->JournalTable->Cells[j][i + 1].c_str();
                    *JournalFile << "</TD>";
                }
            }
            *JournalFile << "</TR>" << endl;
            dls--;
        }
        i++;
    }
    *JournalFile << "</TABLE>" << endl;
ReleaseMutex(hSem);//
 }
 break;
case 2:    // 
 i = 0;

    //
    *JournalFile << "<TABLE border=\"1\"><TR>" << endl;
    for(j = 0; j < fmMain->SlipStatTable->ColCount; j++)
    {
        if(fmMain->SlipStatTable->Cells[j][0] != " ")
        {
            *JournalFile << "<TD width=\"150\">";
            *JournalFile << fmMain->SlipStatTable->Cells[j][0].c_str();
            *JournalFile << "</TD>";
        }
    }
    *JournalFile << "</TR>" << endl;

WaitForSingleObject(hSem, INFINITE);//
    //  
    while(!EqvStr(&pSlipStat[i].Broker, &ZeroStr) && (i < BrokerNum))
    {
        *JournalFile << "<TR>";
        for(j = 0; j < fmMain->SlipStatTable->ColCount; j++)
        {
                *JournalFile << "<TD width=\"150\">";
                *JournalFile << fmMain->SlipStatTable->Cells[j][i + 1].c_str();
                *JournalFile << "</TD>";
        }
        *JournalFile << "</TR>" << endl;
        i++;
    }
    *JournalFile << "</TABLE>" << endl;
ReleaseMutex(hSem);//

 break;

}
 JournalFile->close();
 delete JournalFile;
 return true;
}

//  
bool InitData(void)
{
 int i, j;
    hSem = OpenMutex(SYNCHRONIZE, false, pSemCaption);                           //*
    if(hSem)
    {
     MessageBox(NULL, "!    ,   ,  statistik.dll ", "", MB_OK);
     return false;
    }
    // 
    hSem = CreateMutex(0, false, pSemCaption);
	if(!hSem)
	{
     MessageBox(NULL, "!    !", "", MB_OK);
	 return false;
    }
    hData = CreateFileMapping(	(HANDLE)0xFFFFFFFF,
								NULL,
								PAGE_READWRITE,
								0,
								sizeof(Data),
	                            pDataCaption);
	p = (char*)MapViewOfFile(hData, FILE_MAP_WRITE, 0, 0, 0);
	pData = (Data*)p;
	if(!pData)
	{
		MessageBox(NULL, "!     .", "", MB_OK);
		return false;
	}
    hDeals = CreateFileMapping(	(HANDLE)0xFFFFFFFF,
								NULL,
	                            PAGE_READWRITE,
								0,
								DTsize * sizeof(DealRec),
								pDealsCaption);
    if(!hDeals) return false;
	p = (char*)MapViewOfFile(hDeals, FILE_MAP_WRITE, 0, 0, 0);
    pDeals = (DealRec*)p;
	if(!pDeals)
	{
		MessageBox(NULL, "!     .", "", MB_OK);
		return false;
 	}
    hDlsJournal = CreateFileMapping(	(HANDLE)0xFFFFFFFF,
								NULL,
	                            PAGE_READWRITE,
								0,
								JTsize * sizeof(DealRec),
								pDlsJournalCaption);
    if(!hDlsJournal) return false;
	p = (char*)MapViewOfFile(hDlsJournal, FILE_MAP_WRITE, 0, 0, 0);
    pDlsJournal = (DealRec*)p;
	if(!pDlsJournal)
	{
		MessageBox(NULL, "!     .", "", MB_OK);
		return false;
 	}
    hCaptions = CreateFileMapping(	(HANDLE)0xFFFFFFFF,
								NULL,
	                            PAGE_READWRITE,
								0,
								CTsize * sizeof(MqlStr),
								pCaptionsCaption);
    if(!hCaptions) return false;
    p = (char*)MapViewOfFile(hCaptions, FILE_MAP_WRITE, 0, 0, 0);
	pCaptions = (MqlStr*)p;
	if(!pCaptions)
	{
		MessageBox(NULL, "!     .", "", MB_OK);
		return false;
 	}
    hDigits = CreateFileMapping((HANDLE)0xFFFFFFFF,
								NULL,
	                            PAGE_READWRITE,
								0,
								CurNum * sizeof(int),
								pDigitsCaption);
    if(!hDigits) return false;
    pDigits = (int*)MapViewOfFile(hDigits, FILE_MAP_WRITE, 0, 0, 0);
	if(!pDigits)
	{
		MessageBox(NULL, "!     Digits.", "", MB_OK);
		return false;
 	}
WaitForSingleObject(hSem, INFINITE);//
    //  
   	pData->CurNum      = CurNum;
   	pData->BrokerNum   = BrokerNum;
    pData->DealTableSize = DTsize;
    pData->JournalTableSize = JTsize;
    for(i = 0; i < DTsize; i++)
    {
        pDeals[i].Index			= -1;
        pDeals[i].Broker		= -1;
	    pDeals[i].Cur			= -1;
	    pDeals[i].Magik			= -1;
	    pDeals[i].PriceOpen		= 0;
	    pDeals[i].SlipOpen		= 0;
	    pDeals[i].ReqOpen		= 0;
	    pDeals[i].TimeForOpen	= 0;
	    pDeals[i].PriceClose	= 0;
	    pDeals[i].ReqClose		= 0;
	    pDeals[i].SlipClose		= 0;
	    pDeals[i].TimeForClose	= 0;
    }
    //  
    for(i = 0; i < CurNum; i++) pDigits[i] = 0;
    //      
    for(i = 0; i < JTsize; i++)
     pDlsJournal[i].Broker   = -1;
    //  
    for(i = 0; i < CTsize; i++)    MqlStrCopy(&pCaptions[i], &ZeroStr);          //*
    //        
    pSlipStat = new SlipStatRec[100];
    // 
    for(i = 0; i < 100; i++)
    {
     MqlStrCopy(&pSlipStat[i].Broker, &ZeroStr);
     pSlipStat[i].TotalDeals    = 0;
     pSlipStat[i].SumOpenSlip   = 0;
     pSlipStat[i].SumCloseSlip  = 0;
     pSlipStat[i].Requotes      = 0;
    }

    //     
    if((SlipStatFile = fopen("SlipStat.log", "r")) == 0)
            if((SlipStatFile = fopen("SlipStat.log", "w+")) == 0)
            {
                MessageBox(NULL, "!      ,    .", "", MB_OK);
                ReleaseMutex(hSem);//
                return true;
            }

    i = 0;
    SlipStatRec ssBuff;
    while(!feof(SlipStatFile))
    {
     if(fread(&ssBuff, sizeof(SlipStatRec), 1, SlipStatFile))
     {
      pSlipStat[i] = ssBuff;
      i++;
     }
    }
    fclose(SlipStatFile);
    // 
    TimeInMarketOpen    = new TDateTime[DTsize];
    TimeInMarketClose   = new TDateTime[JTsize];
    OpenTime            = new TDateTime[DTsize];
    CloseTime           = new TDateTime[JTsize];
    for(i = 0; i < DTsize; i++)
    {
        TimeInMarketOpen[i] = StartTime;
        TimeInMarketClose[i]= StartTime;
        OpenTime[i]         = StartTime;
        CloseTime[i]        = StartTime;
    }
ReleaseMutex(hSem);//
    return true;
}

//  
bool RefreshDealTable(void)
{
 if(!Work) return false;
 ActDeals = 0;
 int i, j, k;
WaitForSingleObject(hSem, INFINITE);//
 //  
 for(i = 0, k = 1; i < DTsize; i++, k++)
  if(pDeals[i].Broker == -1)
   for(j = 0; j < fmMain->DealTable->ColCount; j++)
    fmMain->DealTable->Cells[j][k] = "";
  else
  {
   ActDeals++;
   if(!pDeals[i].Checked)
   {
     //   
     if((pDeals[i].Broker > 0) && (pDeals[i].PriceOpen > 0))
        RefreshSlipStat(pDeals[i].Broker, pDeals[i].PriceOpen, pDeals[i].SlipOpen, pDeals[i].ReqOpen, true);

     OpenTime[i] = Time();
     
     pDeals[i].Checked = true;
   }
   TimeInMarketOpen[i] = Time() - OpenTime[i];
    //    
    int ind;
    for(ind = 0; ind < fmMain->clbAD->Count; ind++)
    {
     if(fmMain->clbAD->Checked[ind])
     {
      //   
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        fmMain->DealTable->Cells[ind][k] = IntToStr(pDeals[i].Index);
        continue;
      }
      // 
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        if(pDeals[i].Broker > 0)
        {
            PutToStrBuf(pCaptions[pDeals[i].Broker].string);
            fmMain->DealTable->Cells[ind][k] = StrBuf;
        }
        else
            fmMain->DealTable->Cells[ind][k] = "";
        continue;
      }
      // 
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        if(pDeals[i].Cur >= 0)
        {
            PutToStrBuf(pCaptions[pDeals[i].Cur].string);
            fmMain->DealTable->Cells[ind][k] = StrBuf;
        }
        else
            fmMain->DealTable->Cells[ind][k] = "";
        continue;
      }
      // 
      if(fmMain->clbAD->Items[0][ind] == " ")
      {
        fmMain->DealTable->Cells[ind][0] = " ";
        fmMain->DealTable->Cells[ind][k] = TimeToStr(OpenTime[i]);
        continue;
      }
      // 
      if(fmMain->clbAD->Items[0][ind] == " ")
      {
        fmMain->DealTable->Cells[ind][0] = " ";
        fmMain->DealTable->Cells[ind][k] = TimeToStr(TimeInMarketOpen[i]);
        continue;
      }
      // . 
      if(fmMain->clbAD->Items[0][ind] == " . ")
      {
        fmMain->DealTable->Cells[ind][0] = " . ";
        fmMain->DealTable->Cells[ind][k] = IntToStr(pDeals[i].TimeForOpen);
        continue;
      }
      //
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        if(pDeals[i].Action == SELL)
            fmMain->DealTable->Cells[ind][k] = "SELL";
        else
            fmMain->DealTable->Cells[ind][k] = "BUY";
        continue;
      }
      //
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        fmMain->DealTable->Cells[ind][k] = FloatToStr(pDeals[i].PriceOpen);
        continue;
      }
      //
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        fmMain->DealTable->Cells[ind][k] = IntToStr(pDeals[i].Magik);
        continue;
      }
      //
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        fmMain->DealTable->Cells[ind][k] = IntToStr(pDeals[i].ReqOpen);
        continue;
      }
      //
      if(fmMain->clbAD->Items[0][ind] == "")
      {
        fmMain->DealTable->Cells[ind][0] = "";
        fmMain->DealTable->Cells[ind][k] = IntToStr(pDeals[i].SlipOpen);
        continue;
      }
     }
     else
     {
        fmMain->DealTable->Cells[ind][0] = " ";
        fmMain->DealTable->Cells[ind][k] = " ";
        continue;
     }
    }
  }
ReleaseMutex(hSem);//
 return true;
}
// 
bool RefreshJournalTable(void)
{
 if(!Work) return false;
 SumPft = 0;
WaitForSingleObject(hSem, INFINITE);//
 bool RefFlag;
 if(JDTChangeFlag)
 {
    RefFlag = true;
    JDTChangeFlag = false;
 }
 else
    RefFlag = false;
 // 
 for(int i = 0; i < JTsize; i++)
  if(pDlsJournal[i].Broker > 0)
  {
    //MessageBox(NULL, IntToStr(i).c_str(), "", MB_OK);
   SumPft += pDlsJournal[i].Profit;
   if(!pDlsJournal[i].Checked)
   {
    DoneDeals++;
    fmMain->JournalTable->RowCount = DoneDeals + 1;
    //   
    if((pDlsJournal[i].Broker > 0) && (pDlsJournal[i].PriceClose > 0))
        RefreshSlipStat(pDlsJournal[i].Broker, pDlsJournal[i].PriceClose, pDlsJournal[i].SlipClose, pDlsJournal[i].ReqClose, false);

    CloseTime[i] = Time();
    TimeInMarketClose[i] = CloseTime[i] - OpenTime[pDlsJournal[i].Index];
   }
   if((!pDlsJournal[i].Checked) || RefFlag)
   {
 //   MessageBox(NULL, IntToStr(i).c_str(), "", MB_OK);
    //      
    int ind;
    for(ind = 0; ind < fmMain->clbJD->Count; ind++)
    {
     if(fmMain->clbJD->Checked[ind])
     {
      //   
      if(fmMain->clbJD->Items[0][ind] == "")
      {
        fmMain->JournalTable->Cells[ind][0] = "";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(i);
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == "")
      {
        fmMain->JournalTable->Cells[ind][0] = "";
        if(pDlsJournal[i].Broker > 0)
        {
            PutToStrBuf(pCaptions[pDlsJournal[i].Broker].string);
            fmMain->JournalTable->Cells[ind][i + 1] = StrBuf;
        }
        else
            fmMain->JournalTable->Cells[ind][i + 1] = "";
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == "")
      {
        fmMain->JournalTable->Cells[ind][0] = "";
        if(pDlsJournal[i].Cur >= 0)
        {
            PutToStrBuf(pCaptions[pDlsJournal[i].Cur].string);
            fmMain->JournalTable->Cells[ind][i + 1] = StrBuf;
        }
        else
            fmMain->JournalTable->Cells[ind][i + 1] = "";
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == " ")
      {
         fmMain->JournalTable->Cells[ind][0] = " ";
         fmMain->JournalTable->Cells[ind][i + 1] = TimeToStr(CloseTime[i] - TimeInMarketClose[i]);
         continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == " ")
      {
        fmMain->JournalTable->Cells[ind][0] = " ";
        fmMain->JournalTable->Cells[ind][i + 1] = TimeToStr(CloseTime[i]);
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == " ")
      {
        fmMain->JournalTable->Cells[ind][0] = " ";
        fmMain->JournalTable->Cells[ind][i + 1] = TimeToStr(TimeInMarketClose[i]);
        continue;
      }
      // ...
      if(fmMain->clbJD->Items[0][ind] == " ...")
      {
        fmMain->JournalTable->Cells[ind][0] = " ...";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].TimeForOpen);
        continue;
      }
      // ...
      if(fmMain->clbJD->Items[0][ind] == " ...")
      {
        fmMain->JournalTable->Cells[ind][0] = " ...";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].TimeForClose);
        continue;
      }
      //
      if(fmMain->clbJD->Items[0][ind] == "")
      {
        fmMain->JournalTable->Cells[ind][0] = "";
        if(pDlsJournal[i].Action == SELL)
            fmMain->JournalTable->Cells[ind][i + 1] = "SELL";
        else
            fmMain->JournalTable->Cells[ind][i + 1] = "BUY";
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == " ")
      {
        fmMain->JournalTable->Cells[ind][0] = " ";
        fmMain->JournalTable->Cells[ind][i + 1] = FloatToStr(pDlsJournal[i].PriceOpen);
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == " ")
      {
        fmMain->JournalTable->Cells[ind][0] = " ";
        fmMain->JournalTable->Cells[ind][i + 1] = FloatToStr(pDlsJournal[i].PriceClose);
        continue;
      }
      //
      if(fmMain->clbJD->Items[0][ind] == "")
      {
        fmMain->JournalTable->Cells[ind][0] = "";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].Magik);
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == "  .")
      {
        fmMain->JournalTable->Cells[ind][0] = "  .";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].ReqOpen);
        continue;
      }
      // 
      if(fmMain->clbJD->Items[0][ind] == "  .")
      {
        fmMain->JournalTable->Cells[ind][0] = "  .";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].ReqClose);
        continue;
      }
      // open
      if(fmMain->clbJD->Items[0][ind] == ".  .")
     {
        fmMain->JournalTable->Cells[ind][0] = ".  .";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].SlipOpen);
        continue;
      }
      // close
      if(fmMain->clbJD->Items[0][ind] == ".  .")
     {
        fmMain->JournalTable->Cells[ind][0] = ".  .";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].SlipClose);
        continue;
      }
      //
      if(fmMain->clbJD->Items[0][ind] == "")
      {
        fmMain->JournalTable->Cells[ind][0] = "";
        fmMain->JournalTable->Cells[ind][i + 1] = IntToStr(pDlsJournal[i].Profit);
        continue;
      }
     }
     else
     {
        fmMain->JournalTable->Cells[ind][0] = " ";
        fmMain->JournalTable->Cells[ind][i + 1] = " ";
        continue;
     }
    }
   }
   if(!pDlsJournal[i].Checked)  pDlsJournal[i].Checked = true;
  }
  else  break;
  //     
  if(DoneDeals > 0)
   {
    fmMain->labJDSumPft->Caption = IntToStr(SumPft);
    fmMain->labJDAvgPft->Caption = FloatToStrF(SumPft / DoneDeals, ffGeneral, 4, 0);
   }
ReleaseMutex(hSem);//
  return true;
}

// 
void RefreshSlipStatTable(void)
{
 int i = 0;
 while((!EqvStr(&pSlipStat[i].Broker, &ZeroStr)) && (i < 100))
 {
  PutToStrBuf(pSlipStat[i].Broker.string);
  fmMain->SlipStatTable->Cells[0][i+1] = StrBuf;
  fmMain->SlipStatTable->Cells[1][i+1] = IntToStr(pSlipStat[i].TotalDeals);
  fmMain->SlipStatTable->Cells[2][i+1] = FloatToStr(pSlipStat[i].SumOpenSlip + pSlipStat[i].SumCloseSlip);
  fmMain->SlipStatTable->Cells[3][i+1] = FloatToStr(pSlipStat[i].SumOpenSlip);
  fmMain->SlipStatTable->Cells[4][i+1] = FloatToStr(pSlipStat[i].SumCloseSlip);

  if(pSlipStat[i].TotalDeals > 0)
  {
   fmMain->SlipStatTable->Cells[5][i+1] = FloatToStrF(pSlipStat[i].SumOpenSlip / pSlipStat[i].TotalDeals, ffGeneral, 3, 0);
   fmMain->SlipStatTable->Cells[6][i+1] = FloatToStrF(pSlipStat[i].SumCloseSlip / pSlipStat[i].TotalDeals, ffGeneral, 3, 0);
  }
  fmMain->SlipStatTable->Cells[7][i+1] = IntToStr(pSlipStat[i].Requotes);
  i++;
 }
}

void RefreshStats(void)
{
 fmMain->labActDls->Caption  = IntToStr(ActDeals);
 fmMain->labDoneDls->Caption = IntToStr(DoneDeals);
}

// 
void Deinit(void)
{
 if(Work)
 {
  RefreshSlipStatFile();

  UnmapViewOfFile(pData);
  CloseHandle(hData);
  UnmapViewOfFile(pDeals);
  CloseHandle(hDeals);
  UnmapViewOfFile(pDlsJournal);
  CloseHandle(hDlsJournal);
  UnmapViewOfFile(pCaptions);
  CloseHandle(hCaptions);
  UnmapViewOfFile(pDigits);
  CloseHandle(hDigits);
  CloseHandle(hSem);
  delete [] StrBuf;
  delete [] pSlipStat;
  delete [] TimeInMarketOpen;
  delete [] TimeInMarketClose;
  delete [] OpenTime;
  delete [] CloseTime;
  Work = false;
 }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::btnStartClick(TObject *Sender)
{
 BrokerNum      = udBN->Position;
 CurNum         = udCN->Position;
 DTsize         = udDTS->Position;
 CTsize         = BrokerNum + CurNum;
 JTsize         = udJTS->Position;
 Work           = InitData();

 if(!Work)
 {
  MessageBox(NULL, " !", "", MB_OK);
  exit(0);
 }
 btnStart->Enabled = false;
 udBN->Enabled = false;
 edBN->Enabled = false;
 udCN->Enabled = false;
 edCN->Enabled = false;
 udDTS->Enabled = false;
 edDTS->Enabled = false;
 udJTS->Enabled = false;
 edJTS->Enabled = false;

 DealTable->RowCount = DTsize + 1;
 DealTable->ColCount = clbAD->Count;
 JournalTable->RowCount = 2;
 JournalTable->ColCount = clbJD->Count;

 fmMain->SlipStatTable->RowCount = BrokerNum + 1;
 fmMain->SlipStatTable->Cells[0][0] = "";
 fmMain->SlipStatTable->Cells[1][0] = " ";
 fmMain->SlipStatTable->Cells[2][0] = "  ";
 fmMain->SlipStatTable->Cells[3][0] = "  ";
 fmMain->SlipStatTable->Cells[4][0] = "  ";
 fmMain->SlipStatTable->Cells[5][0] = "  ";
 fmMain->SlipStatTable->Cells[6][0] = "  ";
 fmMain->SlipStatTable->Cells[7][0] = " ";

 fmMain->Caption = fmMain->Caption + "  [ " + DateToStr(Date()) + "  " + TimeToStr(Time()) + "]";
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::SecTimerTimer(TObject *Sender)
{
 if(Work)
 {
WaitForSingleObject(hSem, INFINITE);//
  if(!RefreshDealTable())
  {
   ReleaseMutex(hSem);//
   exit;
  }
  if(!RefreshJournalTable())
  {
   ReleaseMutex(hSem);//
   exit;
  }
  RefreshSlipStatTable();
ReleaseMutex(hSem);//

  RefreshStats();

  if(l8timer)
  {
    l8timer--;
    if(!l8timer)  Label8->Caption = "";
  }
  if(l9timer)
  {
    l9timer--;
    if(!l9timer)  Label9->Caption = "";
  }
  if(l10timer)
  {
    l10timer--;
    if(!l10timer)  Label10->Caption = "";
  }
 }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::btnStopClick(TObject *Sender)
{
 if(Work)
 {
  if(MessageBox(NULL, " ?", "", MB_YESNO|MB_ICONEXCLAMATION) == IDYES)
  {
   Deinit();
   fmMain->Close();
  }
 }
 else
 {
  Deinit();
  fmMain->Close();
 }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::FormCreate(TObject *Sender)
{
 StrCopy(&ZeroStr, " ");
 for(int i = 0; i < clbAD->Count; i++)  clbAD->Checked[i] = true;
 for(int i = 0; i < clbJD->Count; i++)  clbJD->Checked[i] = true;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::btnMinClick(TObject *Sender)
{
 Application->Minimize();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::FormClose(TObject *Sender, TCloseAction &Action)
{
 if(Work) Deinit();
}
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
    : TForm(Owner)
{

}
//---------------------------------------------------------------------------
void __fastcall TfmMain::clbADClick(TObject *Sender)
{
    //ADTChangeFlag = true;
    int i;
    for(i = 0; i < clbAD->Count; i++)
        if(clbAD->Selected[i])
        {
            clbADSel = i;
            break;
        }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::SpeedButton1Click(TObject *Sender)
{
//    ADTChangeFlag = true;
    if(clbADSel > 0)
    {
        clbAD->Selected[clbADSel] = false;
        clbAD->Items[0].Move(clbADSel, clbADSel - 1);
        clbADSel--;
        clbAD->Selected[clbADSel] = true;
    }
}

//---------------------------------------------------------------------------

void __fastcall TfmMain::SpeedButton2Click(TObject *Sender)
{
//    ADTChangeFlag = true;
    if((clbADSel < clbAD->Count - 1) && (clbADSel >= 0))
    {
        clbAD->Selected[clbADSel] = false;
        clbAD->Items[0].Move(clbADSel, clbADSel + 1);
        clbADSel++;
        clbAD->Selected[clbADSel] = true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::clbJDClick(TObject *Sender)
{
    JDTChangeFlag = true;
    int i;
    for(i = 0; i < clbJD->Count; i++)
        if(clbJD->Selected[i])
        {
            clbJDSel = i;
            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::SpeedButton4Click(TObject *Sender)
{
    JDTChangeFlag = true;
    if(clbJDSel > 0)
    {
        clbJD->Selected[clbJDSel] = false;
        clbJD->Items[0].Move(clbJDSel, clbJDSel - 1);
        clbJDSel--;
        clbJD->Selected[clbJDSel] = true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::SpeedButton3Click(TObject *Sender)
{
    JDTChangeFlag = true;
    if((clbJDSel < clbJD->Count - 1) && (clbJDSel >= 0))
    {
        clbJD->Selected[clbJDSel] = false;
        clbJD->Items[0].Move(clbJDSel, clbJDSel + 1);
        clbJDSel++;
        clbJD->Selected[clbJDSel] = true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Button1Click(TObject *Sender)
{
    if(edADFN->Text.Length() > 0)
        if(!RefreshJournalFile(edADFN->Text.c_str(), 0))
            MessageBox(NULL, "   .", "", MB_OK|MB_ICONERROR);
        else
        {
            Label9->Caption = "  ";
            l9timer = 3;
        }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Button2Click(TObject *Sender)
{
    if(edJDFN->Text.Length() > 0)
        if(!RefreshJournalFile(edJDFN->Text.c_str(), 1))
            MessageBox(NULL, "   .", "", MB_OK|MB_ICONERROR);
        else
        {
            Label8->Caption = "  ";
            l8timer = 3;
        }
}
//---------------------------------------------------------------------------
      
void __fastcall TfmMain::Button3Click(TObject *Sender)
{
    SaveDialog->Execute();
    if(SaveDialog->FileName.Length() > 0)
        edADFN->Text = SaveDialog->FileName;// + ".html";
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Button4Click(TObject *Sender)
{
    SaveDialog->Execute();
    if(SaveDialog->FileName.Length() > 0)
        edJDFN->Text = SaveDialog->FileName;// + ".html";
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::SpeedButton5Click(TObject *Sender)
{
 for(int i = 0; i < clbAD->Count; i++)  clbAD->Checked[i] = true;
 //JDTChangeFlag = true;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::SpeedButton6Click(TObject *Sender)
{
 for(int i = 0; i < clbJD->Count; i++)  clbJD->Checked[i] = true;
 JDTChangeFlag = true;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Button6Click(TObject *Sender)
{
    SaveDialog->Execute();
    if(SaveDialog->FileName.Length() > 0)
        edSFN->Text = SaveDialog->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Button5Click(TObject *Sender)
{
    if(edSFN->Text.Length() > 0)
        if(!RefreshJournalFile(edSFN->Text.c_str(), 2))
            MessageBox(NULL, "   .", "", MB_OK|MB_ICONERROR);
        else
        {
            Label10->Caption = "  ";
            l10timer = 3;
        }

}
//---------------------------------------------------------------------------

